unit UserPlayer;

interface
uses
  PokerPlayer;
type
  TPlayer = class(TPlaying)
  private
    FAccount : integer;
    procedure SetAccount (AValue : integer);
  public
    procedure Bet (AValue : integer);
    procedure Raize (const comp : TPlaying; AValue : integer);
    procedure Call (const comp : TPlaying);
    procedure Pass;
    property Account: integer read FAccount write setAccount;
  end;

implementation

procedure TPlayer.setAccount (AValue : integer);
begin
  if FAccount <> AValue then
    FAccount := AValue;
end;

procedure TPlayer.Raize(const comp : TPlaying; AValue : integer);
begin
  if not Comp.Raized then
    BetValue := comp.BetValue + AValue      // If raising a bet
  else
    BetValue := comp.RaizeValue + AValue;   // If raising a raise
  RaizeValue := AValue;
  Raized := true;
  Dec (Faccount, BetValue);
end;

procedure TPlayer.Bet (AValue : integer) ;
begin
  BetValue := AValue;
  Dec (Faccount, BetValue);
end;

procedure TPlayer.Call(const comp : TPlaying);
begin
  if not Comp.Raized then
    BetValue := comp.BetValue
  else
    BetValue := comp.RaizeValue;
  Called := true;
  Dec (Faccount, BetValue);
end;

procedure TPlayer.Pass;
begin
     Passed := true;
     BetValue := 0;
end;
end.
